# Generated by Django 4.0.4 on 2022-06-08 08:00

from django.db import migrations
from wagtail.blocks import StreamValue


def plain_to_structured(page):
    block = []
    mapped = False
    if page.footperson_coord:
        block.append(
            {
                "type": "footer_person_list",
                "value": {
                    "position": page.footperson_coord_title,
                    "person": page.footperson_coord.id,
                },
            }
        )
        mapped = True
    if page.footperson_electman:
        block.append(
            {
                "type": "footer_person_list",
                "value": {
                    "position": page.footperson_electman_title,
                    "person": page.footperson_electman.id,
                },
            }
        )
        mapped = True

    if page.footperson_media:
        block.append(
            {
                "type": "footer_person_list",
                "value": {
                    "position": page.footperson_media_title,
                    "person": page.footperson_media.id,
                },
            }
        )
        mapped = True

    return block, mapped


def structured_to_plain(page):
    edited = False
    for idx, block in enumerate(page.footer_person_list.raw_data):
        if idx > 2:
            break
        elif idx == 0:
            page.footperson_coord_id = block["value"]["person"]
            page.footperson_coord_title = block["value"]["position"]
            edited = True
        elif idx == 1:
            page.footperson_electman_id = block["value"]["person"]
            page.footperson_electman_title = block["value"]["position"]
            edited = True
        elif idx == 2:
            page.footperson_media_id = block["value"]["person"]
            page.footperson_media_title = block["value"]["position"]
            edited = True

    if edited:
        page.save()


def backwards(apps, schema_editor):
    DistrictHomePage = apps.get_model("district", "DistrictHomePage")

    for page in DistrictHomePage.objects.all():
        structured_to_plain(page)


def forwards(apps, schema_editor):
    DistrictHomePage = apps.get_model("district", "DistrictHomePage")

    for page in DistrictHomePage.objects.all():
        footer_person_list, mapped = plain_to_structured(page)

        if mapped:
            page.footer_person_list = StreamValue(
                page.footer_person_list, footer_person_list, is_lazy=True
            )
            page.save()


class Migration(migrations.Migration):
    dependencies = [
        ("district", "0083_districthomepage_footer_person_list"),
    ]

    operations = [
        migrations.RunPython(forwards, backwards),
        migrations.RemoveField(
            model_name="districthomepage",
            name="footperson_coord",
        ),
        migrations.RemoveField(
            model_name="districthomepage",
            name="footperson_coord_title",
        ),
        migrations.RemoveField(
            model_name="districthomepage",
            name="footperson_electman",
        ),
        migrations.RemoveField(
            model_name="districthomepage",
            name="footperson_electman_title",
        ),
        migrations.RemoveField(
            model_name="districthomepage",
            name="footperson_media",
        ),
        migrations.RemoveField(
            model_name="districthomepage",
            name="footperson_media_title",
        ),
    ]
